; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; LCD 2x16 4x16 4x20 ZEICHEN													
;																				
; LCD-INITIALISIERUNG															
LCD_INITIALISIERUNG:
	; auf LOW				
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
	cbi (LCD_EN_PORT),(LCD_EN)
	cbi (LCD_RS_PORT),(LCD_RS)
	; auf Ausgang			
	sbi (LCD_DATA0_DDR),(LCD_DATA0)
	sbi (LCD_DATA1_DDR),(LCD_DATA1)
	sbi (LCD_DATA2_DDR),(LCD_DATA2)
	sbi (LCD_DATA3_DDR),(LCD_DATA3)
	sbi (LCD_RS_DDR),(LCD_RS)
	sbi (LCD_EN_DDR),(LCD_EN)
	; INITIALISIERUNG		
    cbi (LCD_RS_PORT),(LCD_RS)	; RS aus (low)				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)  	; x03 muss 3mal hintereinander gesendet werden zur Initialisierun
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	rcall LCD_ENABLE					; 1	
	rcall LCD_ENABLE					; 2	
	rcall LCD_ENABLE					; 3	
    ldi temp, 0b00000010        ;4bit-Modus einstellen		
 	rcall LCD_COMMAND_TEMP
    ldi temp, 0b00000001        ; DISPLAY lschen			
 	rcall LCD_COMMAND_TEMP
   ;ldi temp, 0b00001111 
    ldi temp, 0b00001100        ; DISPLAY ein / CURSOR blinken
 	rcall LCD_COMMAND_TEMP
    ldi temp, 0b00000110        ; Cursor Auto-Increment		
 	rcall LCD_COMMAND_TEMP
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; erzeugt den Enable-Puls												  		
LCD_ENABLE:
	sbi (LCD_EN_PORT),(LCD_EN) 					; Enable high		
   	rcall wait_50us                   			; kurze PAUSE		
	cbi (LCD_EN_PORT),(LCD_EN)  				; Enable low		
	rjmp  wait_50us                   			; kurze PAUSE		
; ##############################################################################
; ##############################################################################
; ##############################################################################
; sendet ein Datenbyte an das LCD										  		
; INPUT: temp															  		
LCD_DATA_TEMP:
	sbi (LCD_RS_PORT),(LCD_RS) 			; RS ein/auf DATA (high)				
;-------------------------------------------------------------------------------
LCD_DATA_TEMP_RS:
	SBRS temp,4							; SPRUNG, wenn BIT SET				
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRS temp,5
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRS temp,6
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRS temp,7
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,4							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,5
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,6
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,7
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall LCD_ENABLE        			; Enable-Routine aufrufen				
;-------------------------------------------------------------------------------
	SBRS temp,0							; SPRUNG, wenn BIT SET					
	cbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRS temp,1
	cbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRS temp,2
	cbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRS temp,3
	cbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	SBRC temp,0							; SPRUNG, wenn BIT clear				
	sbi (LCD_DATA0_PORT),(LCD_DATA0)
	SBRC temp,1
	sbi (LCD_DATA1_PORT),(LCD_DATA1)
	SBRC temp,2
	sbi (LCD_DATA2_PORT),(LCD_DATA2)
	SBRC temp,3
	sbi (LCD_DATA3_PORT),(LCD_DATA3)
;-------------------------------------------------------------------------------
	rcall LCD_ENABLE        			; Enable-Routine aufrufen				
	rjmp  wait_10us						; Pause 								
; ##############################################################################
; ##############################################################################
; ##############################################################################
;sendet einen Befehl an das LCD;wie lcd_data, nur ohne RS zu setzen		  		
; INPUT: temp															  		
LCD_COMMAND_TEMP:                            
    cbi (LCD_RS_PORT),(LCD_RS)			;	 RS aus (low)				
	rcall LCD_DATA_TEMP_RS
	rjmp wait_10ms						; Pause (wichtig)				
; ##############################################################################
; ##############################################################################
; ##############################################################################
; eine Text anzeigen INP: Z													
ANZEIGE_TEXT:
	LPM temp, Z+   			; aus Tabelle laden und Zeiger um 1 erhhen	
	tst temp  			
	breq ANZEIGE_TEXT_e 	; Sprung	
	rcall LCD_DATA_TEMP		; Anzeige	
	rjmp ANZEIGE_TEXT
ANZEIGE_TEXT_e:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
LCD_CLEAR:
   	ldi temp, 0b00000001
    rcall LCD_COMMAND_TEMP
	rcall wait_5ms						; Pause (wichtig)				
	rjmp ZEILE1
;-------------------------------------------------------------------------------
ZEILE1:
 	ldi temp, 0b00000010
	rjmp LCD_COMMAND_TEMP
;-------------------------------------------------------------------------------
ZEILE2:
 	ldi temp, 0b11000000 
	rjmp LCD_COMMAND_TEMP
;-------------------------------------------------------------------------------
ZEILE3:
	ldi temp, 0b10010000 	; LCD 4x16	
; 	ldi temp, 0b10010100  	; LCD 4x20	
	rjmp LCD_COMMAND_TEMP
;-------------------------------------------------------------------------------
ZEILE4:
	ldi temp, 0b11010000 	; LCD 4x16
;	ldi temp, 0b11010100	; LCD 4x20	
	rjmp LCD_COMMAND_TEMP
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Value: 0...4.294.967.295														
ZAHL_TEMP1:
	clr temp2
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASCII_TEMP1_4
	rjmp LCD_ZIFFER3
; ------------------------------------------------------------------------------
ZAHL_TEMP1_2:
	clr temp3
	clr temp4
	rcall FUNKTION_HEX_ASCII_TEMP1_4
	rjmp LCD_ZIFFER5
; ------------------------------------------------------------------------------
ZAHL_TEMP1_2_3:
	clr temp4
	rcall FUNKTION_HEX_ASCII_TEMP1_4
	rjmp LCD_ZIFFER10
; ------------------------------------------------------------------------------
ZAHL_TEMP1_2_3_4:
	rcall FUNKTION_HEX_ASCII_TEMP1_4
	rjmp LCD_ZIFFER10
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INPUT: TEMP1...TEMP9...R0												  		
LCD_ZIFFER10:
	mov temp, R0			; 1.000.000.000
	rcall LCD_DATA_TEMP
	rcall ASCII_PUNKT		; '.'			
LCD_ZIFFER9:
	mov temp, temp9			; 100.000.000
	rcall LCD_DATA_TEMP
LCD_ZIFFER8:
	mov temp, temp8			; 10.000.000
	rcall LCD_DATA_TEMP	
LCD_ZIFFER7:
	mov temp, temp7			; 1.000.000
	rcall LCD_DATA_TEMP	
LCD_ZIFFER6:
	mov temp, temp6			; 100.000
	rcall LCD_DATA_TEMP	
LCD_ZIFFER5:
	mov temp, temp5			; 10.000
	rcall LCD_DATA_TEMP	
LCD_ZIFFER4:
	mov temp, temp4			; 1.000	
	rcall LCD_DATA_TEMP	
LCD_ZIFFER3:
	mov temp, temp3			; 100	
	rcall LCD_DATA_TEMP	
LCD_ZIFFER2:
	mov temp, temp2			; 10	
	rcall LCD_DATA_TEMP	
LCD_ZIFFER1:
	mov temp, temp1			; 1-er Stelle	
	rcall LCD_DATA_TEMP
	rjmp ASCII_SPACE
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
;	Value: 0...	4.294.967.295													
;																				
;	INPUT: 	temp1	(BYTE1)														
;	 		temp2	(BYTE2)														
;			temp3	(BYTE3)														
;			temp4	(BYTE4)														
;																				
;	OUTPUT:	temp1	(		    1-er Stelle)									
;			temp2	(		   10-er Stelle)									
;			temp3	(         100-er Stelle)									
;			temp4	(       1.000-er Stelle)									
;			temp5	(      10.000-er Stelle)									
;			temp6	(     100.000-er Stelle)									
;			temp7	(   1.000.000-er Stelle)									
;			temp8	(  10.000.000-er Stelle)									
;			temp9	( 100.000.000-er Stelle)									
; 			R0		(1.000.000.000-er Stelle)									
FUNKTION_HEX_ASCII_TEMP1_4:
	clr temp
FUNKTION_HEX_ASC_1000000000:; 100.000.000
	inc temp
	subi temp1, BYTE1    (1000000000)
	sbci temp2, BYTE2    (1000000000)
	sbci temp3, BYTE3    (1000000000)
	sbci temp4, BYTE4    (1000000000)
	brcc FUNKTION_HEX_ASC_1000000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird R0) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000000)
	sbci temp2, BYTE2   (-1000000000)
	sbci temp3, BYTE3   (-1000000000)
	sbci temp4, BYTE4   (-1000000000)

	clr temp
FUNKTION_HEX_ASC_100000000:; 100.000.000
	inc temp
	subi temp1, BYTE1    (100000000)
	sbci temp2, BYTE2    (100000000)
	sbci temp3, BYTE3    (100000000)
	sbci temp4, BYTE4    (100000000)
	brcc FUNKTION_HEX_ASC_100000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp9) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000000)
	sbci temp2, BYTE2   (-100000000)
	sbci temp3, BYTE3   (-100000000)
	sbci temp4, BYTE4   (-100000000)
	clr temp
FUNKTION_HEX_ASC_10000000:; 10.000.000
	inc temp
	subi temp1, BYTE1    (10000000)
	sbci temp2, BYTE2    (10000000)
	sbci temp3, BYTE3    (10000000)
	sbci temp4, BYTE4    (10000000)
	brcc FUNKTION_HEX_ASC_10000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp8) auf dem Stack sichern            
	subi temp1, BYTE1   (-10000000)
	sbci temp2, BYTE2   (-10000000)
	sbci temp3, BYTE3   (-10000000)
	sbci temp4, BYTE4   (-10000000)
	clr temp
FUNKTION_HEX_ASC_1000000:; 1.000.000
	inc temp
	subi temp1, BYTE1    (1000000)
	sbci temp2, BYTE2    (1000000)
	sbci temp3, BYTE3    (1000000)
	brcc FUNKTION_HEX_ASC_1000000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp7) auf dem Stack sichern            
	subi temp1, BYTE1   (-1000000)
	sbci temp2, BYTE2   (-1000000)
	sbci temp3, BYTE3   (-1000000)
	clr temp
FUNKTION_HEX_ASC_100000:
	inc temp
	subi temp1, BYTE1    (100000)
	sbci temp2, BYTE2    (100000)
	sbci temp3, BYTE3    (100000)
	brcc FUNKTION_HEX_ASC_100000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp6) auf dem Stack sichern            
	subi temp1, BYTE1   (-100000)
	sbci temp2, BYTE2   (-100000)
	sbci temp3, BYTE3   (-100000)
	clr temp
FUNKTION_HEX_ASC_10000:
	inc temp
	subi temp1, BYTE1    (10000)
	sbci temp2, BYTE2    (10000)
	sbci temp3, BYTE3    (10000)
	brcc FUNKTION_HEX_ASC_10000
	dec  temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp5) auf dem Stack sichern            
	subi temp1, BYTE1  (-10000)
	sbci temp2, BYTE2  (-10000)
	sbci temp3, BYTE3  (-10000)
	clr temp
FUNKTION_HEX_ASC_1000:
	inc temp
	subi temp1, low  (1000)
	sbci temp2, HIGH (1000)
	brcc FUNKTION_HEX_ASC_1000
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp4) auf dem Stack sichern            
	subi temp1, low  (-1000)
	sbci temp2, HIGH (-1000)
	clr temp
FUNKTION_HEX_ASC_100:
	inc temp
	subi temp1, low  (100)
	sbci temp2, HIGH (100)
	brcc FUNKTION_HEX_ASC_100
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp3) auf dem Stack sichern            
	subi temp1, low  (-100)
	sbci temp2, HIGH (-100)
	clr temp
FUNKTION_HEX_ASC_10:
	inc temp
	subi temp1, low  (10)
	sbci temp2, HIGH (10)
	brcc FUNKTION_HEX_ASC_10
	dec temp
	subi temp, -48		; HEX->ASC
	push temp           ; temp (wird temp2) auf dem Stack sichern            
	subi temp1, low  (-10)
	sbci temp2, HIGH (-10)
FUNKTION_HEX_ASC_1:	
	subi temp1, -48		; HEX->ASC

	pop	TEMP2			; LESEN vom STACK (KOPIE)
	pop	TEMP3			; LESEN vom STACK (KOPIE)
	pop	TEMP4			; LESEN vom STACK (KOPIE)
	pop	TEMP5			; LESEN vom STACK (KOPIE)
	pop	TEMP6			; LESEN vom STACK (KOPIE)
	pop	TEMP7			; LESEN vom STACK (KOPIE)
	pop	TEMP8			; LESEN vom STACK (KOPIE)
	pop	TEMP9			; LESEN vom STACK (KOPIE)
	pop R0
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1																
; OUT: (z.B."FF") 															
;																			
LCD_ANZEIGE_HEX_TEMP1:
	push temp		; SICHERUNGSKOPIE						
	push temp1
	mov temp,temp1	; oberes NIBBLE bearbeiten					
	swap temp						; NIBBLES tausch	
	rcall LCD_ANZEIGE_HEX_UMWANDLUNG; INP/OUT: temp		
	rcall LCD_DATA_TEMP				; ANZEIGE			
	mov temp,temp1	; unteres NIBBLE bearbeiten					
	rcall LCD_ANZEIGE_HEX_UMWANDLUNG; INP/OUT: temp		
	rcall LCD_DATA_TEMP				; ANZEIGE			
	pop temp1		; SICHERUNGSKOPIE wieder herstellen		
	pop temp
	ret
;-------------------------------------------------------------------------------
LCD_ANZEIGE_HEX_UMWANDLUNG:
	andi temp,0b00001111	; BITMUSTER	
	cpi temp,10	; vergleich	
	brsh LCD_ANZEIGE_HEX_UMWANDLUNG_A_F
LCD_ANZEIGE_HEX_UMWANDLUNG_0_9:
	subi temp,-48
	ret
LCD_ANZEIGE_HEX_UMWANDLUNG_A_F:
	subi temp,-48-7
	ret

